<div #toast class="toast align-items-center text-bg-warning border-0 position-absolute text-opacity-25 end-0 z-3"
     role="alert" aria-live="assertive" aria-atomic="true">
  <div class="d-flex">
    <div class="toast-body">
      Veuillez tourner votre écran pour que cette présentation s'affiche correctement.
    </div>
    <button type="button" class="btn-close me-2 m-auto" data-bs-dismiss="toast" aria-label="Close"></button>
  </div>
</div>
<div class="reveal">
  <div class="slides">
    <section data-transition="zoom" data-background-color="black" class="full">
      <img src="{{imgAssets.intro}}" alt="Intro" class="full"/>
    </section>
    <section class="full">
      <section>
        <h1>Qu'est-ce qu'un jeu vidéo ?</h1>
        <h2 class="fragment" data-fragment-index="1">D'après Wikipédia</h2>
        <p class="fragment" data-fragment-index="2">
          Un jeu vidéo est un jeu électronique doté d'une interface utilisateur permettant une interaction humaine
          ludique en générant un retour visuel sur un dispositif vidéo.
        </p>
        <h2 class="fragment" data-fragment-index="3">En résumé</h2>
        <div class="container-fluid">
          <div class="row">
            <div class="col">
              <div class="fragment img-group" data-fragment-index="4"
                   style="width: 30vh; aspect-ratio: 1/1; margin: auto;">
                <img style="top: 20%; rotate: 0deg; left: 0; width: 13vh;" src="{{imgAssets.bigAsteroid}}"
                     alt="Sprite gros asteroid"/>
                <img style="top: 59%; rotate: 45deg; left: 67%; width: 7vh;" src="{{imgAssets.mediumAsteroid}}"
                     alt="Sprite moyen asteroid"/>
                <img style="top: 5%; rotate: 45deg; left: 70%; width: 3vh;" src="{{imgAssets.smallAsteroid}}"
                     alt="Sprite petit asteroid"/>
                <img style="top: 64%; rotate: 45deg; left: 22%; width: 7vh;" src="{{imgAssets.vaisseau}}"
                     alt="Sprite vaisseau"/>
                <img style="top: 55%; rotate: 45deg; left: 48%; width: 1.5vh;" src="{{imgAssets.bullet}}"
                     alt="Sprite balle"/>
                <img style="top: 33%; rotate: 45deg; left: 63%; width: 1.5vh;" src="{{imgAssets.bullet}}"
                     alt="Sprite balle"/>
              </div>
            </div>
            <div class="col" style=" text-align: center;">
              <div class="img-group" style=" width: 30vh; aspect-ratio: 1/1; margin: auto;">
                <img class="fragment" data-fragment-index="5" style="top: 40%; left: 5%; width: 13vh;"
                     src="{{imgAssets.manette}}" alt="Manette"/>
                <img class="fragment" data-fragment-index="6" style="top: 5%; left: 40%; width: 13vh;"
                     src="{{imgAssets.clavier}}" alt="Clavier"/>
                <img class="fragment" data-fragment-index="7" style="top: 60%; left: 55%; width: 13vh;"
                     src="{{imgAssets.souris}}" alt="Souris"/>
              </div>
            </div>
          </div>
        </div>
      </section>
      <section class="full" data-transition="zoom">
        <iframe
          data-src="https://www.youtube.com/embed/4Zz4jG1S0Zc?autoplay=1&start=66&end=78&si=BLQbrcVAVUSLL9W8&amp;controls=0&amp"
          title="YouTube video player" frameBorder="0"
          allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share"></iframe>
        <p class="stylized fragment" data-fragment-index="6">
          FUN
        </p>
      </section>
    </section>
    <section class="full">
      <section data-transition="zoom">
        <h1>Que faut-il pour créer un jeu ?</h1>
        <div class='container-fluid'>
          <div class='row'>
            <div class="col text-center fragment" data-fragment-index="1">
              <h2>Un moteur de jeu !</h2>
            </div>
          </div>
          <div class="row">
            <div class="col">
              <div class="img-group" style="width: 100%; aspect-ratio: 16/6; margin: auto;">
                <img class="fragment" data-fragment-index="2" style="top: 20%; left: 7%; width: 30vh;"
                     src="{{imgAssets.gamemaker}}" alt="Logo game maker"/>
                <img class="fragment" data-fragment-index="2" style="top: 48%; left: 4%; width: 20vh;"
                     src="{{imgAssets.phaser}}" alt="Logo phaser"/>
                <img class="fragment" data-fragment-index="4" style="top: 10%; left: calc(50% - 15vh); width: 30vh;"
                     src="{{imgAssets.godot}}" alt="Logo godot"/>
                <img class="fragment" data-fragment-index="3" style="top: 20%; left: 70%; width: 21vh;"
                     src="{{imgAssets.unity}}" alt="Logo unity"/>
                <img class="fragment" data-fragment-index="3" style="top: 52%; left: 80%; width: 17vh;"
                     src="{{imgAssets.unreal}}" alt="logo unreal"/>
              </div>
            </div>
          </div>
        </div>
      </section>
      <section data-transition="zoom">
        <h1>Comment faire mon premier jeu avec Godot ?</h1>
        <div class='container-fluid'>
          <div class='row'>
            <div class="col text-center fragment">
              Aller sur<br/>
              <a target="_blank" href="https://godotengine.org/">https://godotengine.org/</a>
            </div>
          </div>
          <div class="row">
            <div class="col">
              <div class="img-group" style="width: 100%; aspect-ratio: 16/6; margin: auto;">
                <a target="_blank" href="https://godotengine.org/download/windows"
                   style="top: 40%; left: 7%;">
                  <img class="fragment" style="width: 30vh;" src="{{imgAssets.godotDll}}"
                       alt="Bouton de téléchargement de Godot"/>
                </a>
                <div class="fragment text-center" style="position: absolute; top: 15%; left: calc(50% - 15vh / 2)">
                  <img style="position: relative; width: 15vh;" src="{{imgAssets.godotStart}}"
                       alt="Bouton de lancement de Godot"/>
                  <div>Lancer Godot</div>
                </div>
                <img class="fragment" style="top: 40%; left: 80%; width: 20vh;" src="{{imgAssets.godotNew}}"
                     alt="Bouton de créer de projet Godot"/>
                <div class="fragment text-center" style="top: 73%; left: 33%; width: 54vh;">
                  Télécharger les images du jeu :<br/>
                  <a
                    href="https://gitlab.com/benjamin.brasseur.kanoma/asteroid-godot/-/archive/main/asteroid-godot-main.zip?path=art/sprites"
                    target="_blank">
                    https://tinyurl.com/asteroidSpriteBBRZip
                  </a>
                </div>
              </div>
            </div>
          </div>
        </div>
      </section>
      <section data-transition="zoom">
        <h1>Comment ça marche Godot ?</h1>
        <div style="height: calc(100% - 6vh)">
          <img class="full" src="{{imgAssets.godotView}}" alt="Aperçu d'un nouveau projet Godot"/>
        </div>
      </section>
    </section>
    <section>
      <h1>Asteroid, un jeu simple pour commencer</h1>
      <div class='container-fluid'>
        <div class='row'>
          <div class='col'>
            <h2 class="fragment">Asteroid c'est ça :</h2>
            <img class="fragment" style="height: 50vh;" src="{{imgAssets.asteroidGame}}" alt='Asteroid Game'/>
          </div>
          <div class='col'>
            <h2 class="fragment">Quels sont les évènements visuels d'un jeu Asteroid ?</h2>
            <ul>
              <li class="fragment">Un vaisseau</li>
              <li class="fragment">Des astéroides</li>
              <li class="fragment">Des missiles</li>
              <li class="fragment">Un score</li>
              <li class="fragment">Des points de vie</li>
            </ul>
          </div>
        </div>
      </div>
    </section>
    <section class="full">
      <section data-transition="zoom">
        <h1>Il était une fois un petit vaisseau…</h1>
        <div class="img-group" style="width: 100%;  aspect-ratio: 16/6;  margin: auto;">
          <img src="{{imgAssets.vaisseau}}" alt="Vaisseau"
               style="top: calc(50% - 2vh); left: calc(50% - 2vh); width: 4vh;"/>
          <img src="{{imgAssets.arrow}}" alt="Flèche"
               style="top: calc(59% - 2vh); left: calc(47% - 2vh); rotate: 180deg; width: 4vh;"/>
          <p style="top: 67%; left: 37%;">Le vaisseau :)</p>
        </div>
      </section>
      <section data-transition="zoom">
        <h1>… dans l’espace…</h1>
        <div class="img-group" style="width: 100%;  aspect-ratio: 16/6;  margin: auto;  background: black;">
          <img src="{{imgAssets.vaisseau}}" alt="Vaisseau"
               style="top: calc(50% - 2vh); left: calc(50% - 2vh); width: 4vh;"/>
          <p class="t-white" style="top: 67%; left: 37%;">Il fait tout noir !</p>
        </div>
      </section>
      <section data-transition="zoom">
        <h1>… au milieu d’un champ d’astéroïde…</h1>
        <div class="img-group" style="width: 100%;  aspect-ratio: 16/6;  margin: auto;  background: black;">
          <img src="{{imgAssets.bigAsteroid}}" alt="Gros Asteroid"
               style="top: calc(25% - 5vh); left: calc(25% - 5vh); width: 10vh;"/>
          <img src="{{imgAssets.vaisseau}}" alt="Vaisseau"
               style="top: calc(50% - 2vh); left: calc(50% - 2vh); width: 4vh;"/>
          <img src="{{imgAssets.arrow}}" alt="Flèche"
               style="top: calc(37% - 2vh); left: calc(21% - 2vh); rotate:180deg; width: 4vh;"/>
          <p class="t-white" style="top: 46%;  left: 7%;">L'astéroïde pas cool :(</p>
        </div>
      </section>
      <section data-transition="zoom">
        <h1>… en mouvement…</h1>
        <div class="img-group" style="width: 100%;  aspect-ratio: 16/6;  margin: auto;  background: black;">
          <img src="{{imgAssets.bigAsteroid}}" alt="Gros Asteroid" class="moving"
               style="top: calc(25% - 5vh); left: calc(25% - 5vh); width: 10vh;"/>
          <img src="{{imgAssets.vaisseau}}" alt="Vaisseau"
               style="top: calc(50% - 2vh); left: calc(50% - 2vh); width: 4vh;"/>
          <p class="t-white" style="top: 15%; left: 38%;">Et flottez jeunesse !</p>
        </div>
      </section>
      <section data-transition="zoom">
        <h1>… qui errent dans l'espace sans fin.</h1>
        <div class="img-group" style="width: 100%;  aspect-ratio: 16/6;  margin: auto;  background: black;">
          <img src="{{imgAssets.bigAsteroid}}" alt="Gros Asteroid" class="edge-moving"
               style="top: calc(25% - 5vh); left: calc(25% - 5vh); width: 10vh;"/>
          <img src="{{imgAssets.vaisseau}}" alt="Vaisseau"
               style="top: calc(50% - 2vh); left: calc(50% - 2vh); width: 4vh;"/>
          <p class="t-white" style="top: 2%; left: 1%;">Pif</p>
          <p class="t-white" style="top: 81%; left: 38%;">Pouf</p>
        </div>
      </section>
      <section data-transition="zoom">
        <h1>Un vaisseau qui bouge…</h1>
        <div class="img-group" style="width: 100%;  aspect-ratio: 16/6;  margin: auto;  background: black;">
          <img src="{{imgAssets.vaisseau}}" alt="Vaisseau" class="center-moving"
               style="top: calc(50% - 2vh); left: calc(50% - 2vh); width: 4vh;"/>
          <p class="t-white" style="top: 15%; left: 38%;">La classe (ﾉﾟ0ﾟ)ﾉ</p>
        </div>
      </section>
      <section data-transition="zoom">
        <h1>…qui craint les astéroïdes…</h1>
        <div class="img-group" style="width: 100%;  aspect-ratio: 16/6;  margin: auto;  background: black;">
          <img src="{{imgAssets.bigAsteroid}}" alt="Gros Asteroid" class="moving"
               style="top: calc(25% - 5vh); left: calc(25% - 5vh); width: 10vh;"/>
          <img src="{{imgAssets.vaisseau}}" alt="Vaisseau" class="moving-and-die"
               style="top: calc(50% - 2vh); left: calc(50% - 2vh); width: 4vh;"/>
          <p class="t-white" style="top: 15%; left: 38%;">Attention ! Chauffard !</p>
        </div>
      </section>
      <section data-transition="zoom">
        <h1>…mais peut en fait se défendre !</h1>
        <div class="img-group" style="width: 100%;  aspect-ratio: 16/6;  margin: auto;  background: black;">
          <img src="{{imgAssets.bigAsteroid}}" alt="Gros Asteroid" class="moving-and-die"
               style="top: calc(25% - 5vh); left: calc(25% - 5vh); width: 10vh;"/>
          <img src="{{imgAssets.vaisseau}}" alt="Vaisseau"
               style="top: calc(25% - 2vh); left: calc(20% - 2vh); rotate: 90deg;  width: 4vh;"/>
          <img src="{{imgAssets.bullet}}" alt="Balle" class="moving-bullet" style="top: 25%;  left: 20%;  width: 1vh;"/>
          <p class="t-white" style="top: 15%; left: 38%;">Ca t'apprendras à griller la priorité !</p>
        </div>
      </section>
      <section data-transition="zoom">
        <h1>Il était une fois… toujours plus d'Astéroïdes.</h1>
        <div class="img-group" style="width: 100%;  aspect-ratio: 16/6;  margin: auto;  background: black;">
          <img src="{{imgAssets.bigAsteroid}}" alt="Gros Asteroid" class="moving-and-die"
               style="top: calc(25% - 5vh); left: calc(25% - 5vh); width: 10vh;"/>
          <img src="{{imgAssets.vaisseau}}" alt="Vaisseau"
               style="top: calc(25% - 2vh); left: calc(20% - 2vh); rotate: 90deg;  width: 4vh;"/>
          <img src="{{imgAssets.bullet}}" alt="Balle" class="moving-bullet" style="top: 25%;  left: 20%;  width: 1vh;"/>
          <img src="{{imgAssets.mediumAsteroid}}" alt="Moyen Asteroid" class="born-and-move-1"
               style="top: calc(25% - 5vh); left: calc(25% - 5vh); width: 5vh;"/>
          <img src="{{imgAssets.mediumAsteroid}}" alt="Moyen Asteroid" class="born-and-move-2"
               style="top: calc(25% - 5vh); left: calc(25% - 5vh); width: 5vh;"/>
          <p class="t-white" style="top: 12%; left: 4%;">On le nommait le faiseur d'Orphelins</p>
        </div>
      </section>
    </section>
    <section class="full">
      <section>
        <h1 class="center">
          Attendez une seconde…
        </h1>
      </section>
      <section>
        <h1 class="center">
          Mais on a un jeu là en fait ?!
        </h1>
      </section>
      <section>
        <h1 class="center">
          Mais ça manque de quelque chose non ?
        </h1>
      </section>
      <section>
        <h1>Comment améliorer ce jeu ?</h1>
        <ul>
          <li class="fragment">Du scoring</li>
          <li class="fragment">Des bonus/malus</li>
          <li class="fragment">Des effets visuels explosifs</li>
          <li class="fragment">Des points des vies</li>
          <li class="fragment"><h2>Et tout ce qui vous passe par la tête pour avoir un jeu... </h2></li>
        </ul>
      </section>
      <section data-transition="none" class="full">
        <p class="stylized">
          FUN
        </p>
      </section>
      <section>
        <h1 class="center">Bon OK...</h1>
      </section>
      <section>
        <h1 class="center">
          On va ajouter 2 dernières choses.
        </h1>
      </section>
      <section>
        <h1>Un point c'est tout !</h1>
        <div class="img-group" style="width: 100%; aspect-ratio: 16/6; margin: auto; background: black">
          <img src="{{imgAssets.bigAsteroid}}" alt="Gros Asteroid" class="moving-and-die"
               style="top: calc(25% - 5vh); left: calc(25% - 5vh); width: 10vh"/>
          <img src="{{imgAssets.vaisseau}}" alt="Vaisseau"
               style="top: calc(25% - 2vh); left: calc(20% - 2vh); rotate: 90deg; width: 4vh"/>
          <img src="{{imgAssets.bullet}}" alt="Balle" class="moving-bullet" style="top: 25%; left: 20%; width: 1vh"/>
          <img src="{{imgAssets.mediumAsteroid}}" alt="Moyen Asteroid" class="born-and-move-1"
               style="top: calc(25% - 5vh); left: calc(25% - 5vh); width: 5vh"/>
          <img src="{{imgAssets.mediumAsteroid}}" alt="Moyen Asteroid" class="born-and-move-2"
               style="top: calc(25% - 5vh); left: calc(25% - 5vh); width: 5vh"/>
          <p class="t-white score-animate" style="top: 1%;left: 1%">Score: </p>
        </div>
      </section>
      <section>
        <h1>
          1 de perdu; 1 de retrouvé<br/>
          <small>(Tant qu’il reste des PV)</small>
        </h1>
        <div class="img-group" style="width: 100%; aspect-ratio: 16/6; margin: auto; background: black">
          <img src="{{imgAssets.bigAsteroid}}" alt="Gros Asteroid" class="moving"
               style="top: calc(25% - 5vh); left: calc(25% - 5vh); width: 10vh"/>
          <img src="{{imgAssets.vaisseau}}" alt="Vaisseau" class="moving-and-die"
               style="top: calc(50% - 2vh); left: calc(50% - 2vh); width: 4vh"/>
          <p class="t-white" style="top: 1%;left: 1%">Score: 10</p>
          <p class="t-white vie-animate" style="top: 10%;left: 1%">Vies: </p>
        </div>
      </section>
      <section>
        <h1 class="center">
          C’est fini !<br/>
          Mais c’est à vous de continuer désormais !
        </h1>
      </section>
      <section>
        <h1>Et ensuite ?</h1>
        <p class="fragment">
          Vous avez une bonne base pour votre jeu.<br/>
          Il ne vous reste plus qu'à le faire évoluer pour qu'il corresponde à votre vision du fun !
        </p>
        <p class="fragment">
          Voici un exemple de choses à faire :
        </p>
        <ul>
          <li class="fragment">Retravailler les sprites pour qu'ils collent à votre image</li>
          <li class="fragment">Faire évoluer l'interface des scores et PV</li>
          <li class="fragment">Ajout des bonus et malus</li>
          <li class="fragment">Modifier comment les points sont gagnés/perdus</li>
        </ul>
      </section>
    </section>
    <section class="full">
      <section>
        <h1 class="center">Avant de terminer, <span class="fragment">un potit quizz !</span></h1>
      </section>
      <section>
        <h2 class="fragment">Quel nom donne-t-on à une image que l'on peut déplacer dans notre jeu ?</h2>
        <div class="fragment">
          <p><b>Le Sprite</b></p>
          <p class="fragment">
            <i>Le saviez-vous ?</i><br/><br/>
            Le sprite désigne à l'origine les petites créatures telles que les gnomes, lutins, etc. <br/>
            Mais aussi des esprits de l'air tel que des Sylphes. <br/>
            C'est notamment cette caractéristique d'élément qui flotte dans le décors du jeu qui a amené à utiliser le
            terme de sprite !
          </p>
        </div>
        <h2 class="fragment margin">Quel est le nom de la node permettant d'afficher un sprite dans notre jeu ?</h2>
        <p class="fragment"><b>Sprite2D</b></p>
      </section>
      <section>
        <h2 class="fragment">Quelles node permet de déplacer mon objet tout en gérant les collisions avec les autres
          objets ?</h2>
        <div class="fragment">
          <ul>
            <li>
              <b>CharacterBody2D</b> <br/>
              Notamment via ses fonctions <code>move_and_slide()</code> et <code>move_and_collide(direction)</code>.
            </li>
            <li>
              <b>CollisionPolygon2D</b> (ou CollisionShape2D si vous utilisez des formes basiques).
            </li>
          </ul>
        </div>
        <h2 class="fragment margin">Quelle classe me permet de détecter les intéractions du joueur ? </h2>
        <p class="fragment">
          <b>Input</b><br/>
          Notamment via les fonctions telles que <code>is_key_pressed(Touche)</code> ou
          <code>is_action_pressed(Action)</code>.
        </p>
        <h2 class="fragment margin">Quelle est la différence entre les fonctions _process et _physics_process</h2>
        <p class="fragment">
          La régularité de l'appel ! <br/>
          _process est appelée à chaque frame. (Variable en fonction du matériel du joueur)<br/>
          _physics_process est appelée de manière régulière. (Utilisé principalement pour faire des calculs de
          simulation de physique)
        </p>
      </section>
      <section>
        <h2>Quelles fonctions permettent de créer et détruire des objets ?</h2>
        <p class="fragment">
          <a href="#/concepts-PackedScene">PackedScene</a><b>.instantiate()</b> !
          <br/>
          Et <b>queue_free()</b> !
        </p>
        <h2 class="fragment margin">Qu'est-ce qui permet de communiquer facilement entre différents objets ?</h2>
        <p class="fragment">
          Les <b>Signaux</b> !
        </p>
        <h2 class="fragment margin">Qu'est-ce qui permet de référencer facilement des Nodes dans du code ?</h2>
        <p class="fragment">
          Les <b>Unique Name</b> !
        </p>
        <p class="fragment text-center">
          Félicitations ! Vous avez terminé le quizz !<br/>
          Une documentation se trouve à la fin de cette diapo si jamais vous souhaitez retrouver ce qui a été abordé
          pendant cette session !
        </p>
      </section>
      <section>
        <h1>Pour conclure.</h1>
        <div class="img-group" style="width: 100%; aspect-ratio: 16/8; margin: auto">
          <p class="fragment" style="top: 5%; left: 5%">Il est facile de commencer à créer des jeux</p>
          <p class="fragment" style="top: 12%; left: 13%">Notez vos idées et essayez de les mettres en oeuvre !</p>
          <p class="fragment" style="top: 34%; left: 5%">Vous allez être trop ambitieux pour votre bien</p>
          <p class="fragment" style="top: 42%; left: 21%">Et c'est ok ! (On apprend en faisant des erreurs)</p>
          <p class="fragment" style="top: 58%; left: 30%">Vous voulez vous challenger ?</p>
          <p class="fragment" style="top: 65%; left: 30%">Participez à des games jams !</p>
          <img class="fragment" src="{{imgAssets.gmtk}}"
               style="top: 79%; left: 13%; width: 20vh; background: black; border-radius: 2vh"
               alt="Logo GMTK Jam 2023"/>
          <img class="fragment" src="{{imgAssets.ludum}}" style="top: 86%; left: 70%; width: 20vh"
               alt="Logo Ludum Dare"/>
          <img class="fragment" src="{{imgAssets.ggj}}" style="top: 73%; left: 46%; width: 15vh"
               alt="Logo Global Game Jam"/>
        </div>
      </section>
      <section>
        <h2 class="center m-auto">Vous avez des questions ?</h2>
        <div class="center">
          Si vous souhaitez voir mes petits projets :<br/>
          <a href="https://benlaod.itch.io" target="_blank">benlaod.itch.io</a><br/>
          <br/>
          Les sources du jeu :<br/>
          <a href="https://gitlab.com/benjamin.brasseur.kanoma/asteroid-godot" target="_blank">gitlab.com/benjamin.brasseur.kanoma/asteroid-godot</a>
        </div>
      </section>
    </section>
    <section class="full">
      <section id="concepts-summary">
        <h1>Petit récap de ce qu'on a utilisé</h1>
        <div class="container-fluid">
          <div class="row">
            <div class="col">
              <ul>
                <li><a href="https://gitlab.com/benjamin.brasseur.kanoma/asteroid-godot" target="_blank">Code source du
                  jeu</a></li>
                <li><a href="#/concepts-Node">Node</a></li>
                <li><a href="#/concepts-Scene">Scene</a></li>
                <li><a href="#/concepts-CharacterBody2D">CharacterBody2D</a></li>
                <li><a href="#/concepts-CharacterBody2DSpace">CharacterBody2DSpace</a></li>
                <li><a href="#/concepts-HandlingOutside">HandlingOutside (Une Node faite maison)</a></li>
                <li><a href="#/concepts-ColorRect">ColorRect</a></li>
                <li><a href="#/concepts-Label">Label</a></li>
                <li><a href="#/concepts-Sprite2D">Sprite2D</a></li>
                <li><a href="#/concepts-CollisionPolygon2D">CollisionPolygon2D</a></li>
              </ul>
            </div>
            <div class="col">
              <ul>
                <li><a href="#/concepts-FonctionBases-ready">Fonctions de base</a></li>
                <li><a href="#/concepts-Types">Types</a></li>
                <li><a href="#/concepts-Input">Input</a></li>
                <li><a href="#/concepts-UniqueName">Unique Name</a></li>
                <li><a href="#/concepts-Export">&#64;export</a></li>
                <li><a href="#/concepts-Signaux">Signaux</a></li>
                <li><a href="#/concepts-PackedScene">PackedScene</a></li>
              </ul>
            </div>
          </div>
        </div>
      </section>
      <section id="concepts-Node">
        <h1>Node</h1>
        <a href="#/concepts-summary">Retour au sommaire</a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/4.x/classes/class_node.html" target="_blank">
          Documentation
        </a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/4.x/getting_started/introduction/key_concepts_overview.html#nodes"
           target="_blank">
          Guide
        </a>
        <br/>
        <br/>
        Les Nodes sont les éléments principaux qui permettent de faire un jeu sur Godot.<br/>
        Elles sont constituées de différents attributs :
        <ul>
          <li>Un nom</li>
          <li>Des propriétés qui peuvent être modifiées (Ex: Une position)</li>
          <li>Des fonctions pour déterminer son comportement (Ex: _ready(),_process())</li>
          <li>Elles peuvent être étendues (Node2D est étendue depuis Node)</li>
          <li>Une Node peut avoir plusieurs Nodes enfants.
            <ul>
              <li>Cela donnera un arbre de Nodes.</li>
              <li>Cela permet d'associer plusieurs comportements pour créer un élément dynamique de votre jeu.</li>
            </ul>
          </li>
        </ul>
      </section>
      <section id="concepts-Scene">
        <h1>Scene</h1>
        <a href="#/concepts-summary">Retour au sommaire</a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/4.x/getting_started/introduction/key_concepts_overview.html#scenes"
           target="_blank">
          Guide
        </a><br/>
        <br/>
        Une scène est un ensemble (arbre) de <a href="#/concepts-Node">Nodes</a>, qui est sauvegardé en tant que fichier
        dans le projet.<br/>
        Les scènes peuvent être utilisées comme une fenêtre de jeux, ou comme un regroupement de Nodes.<br/>
      </section>
      <section id="concepts-CharacterBody2D">
        <h1>CharacterBody2D</h1>
        <a href="#/concepts-summary">Retour au sommaire</a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/4.x/classes/class_characterbody2d.html" target="_blank">
          Documentation
        </a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/4.x/tutorials/physics/using_character_body_2d.html">
          Guide
        </a><br/>
        <br/>
        CharacterBody2D est une <a href="#/concepts-Node">Node</a> qui permet de déplacer un objet.<br/>
        Il permet aussi d'interagir avec d'autres objets (On parle de collision).<br/>
        Pour cela, il faut aussi une node <a href="#/concepts-CollisionPolygon2D">Collision2D</a> attachée comme enfant.<br/><br/>
        Exemple :
        <div class="img-group" style="width: 100%; aspect-ratio: 16/8; margin: auto;">
          <img src="{{imgAssets.characterbody2DCollision}}" style="top: 2%; left: 0; width: 40vh;"
               alt="Collision2D est enfant de CharacterBody2D"/>
        </div>
      </section>
      <section id="concepts-CharacterBody2DSpace">
        <h1>CharacterBody2DSpace</h1>
        <a href="#/concepts-summary">Retour au sommaire</a><br/>
        <pre style="height: 80%;">
        <code data-line-numbers class="no-highlight gdscript" [innerHTML]="Characterbody2dspace.code"
              style="height: 100%;"></code>
        </pre>
      </section>
      <section id="concepts-HandlingOutside">
        <h1>HandlingOustide (Une Node faite maison)</h1>
        <a href="#/concepts-summary">Retour au sommaire</a>
        <pre style="height: 80%;">
        <code class="no-highlight gdscript" data-line-numbers style="height: 100%;" [innerHTML]="Handlingout.code">
        </code>
        </pre>
      </section>
      <section id="concepts-ColorRect">
        <h1>ColorRect</h1>
        <a href="#/concepts-summary">Retour au sommaire</a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/4.x/classes/class_colorrect.html" target="_blank">
          Documentation
        </a><br/>
        <br/>
        ColorRect est une <a href="#/concepts-Node">Node</a> qui permet de dessiner un rectangle de couleur dans le jeu.
      </section>
      <section id="concepts-Label">
        <h1>Label</h1>
        <a href="#/concepts-summary">Retour au sommaire</a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/4.x/classes/class_label.html#class-label" target="_blank">
          Documentation
        </a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/4.x/tutorials/ui/index.html#" target="_blank">
          Guide
        </a><br/>
        <br/>
        Label est une <a href="#/concepts-Node">Node</a> qui permet d'afficher du texte.<br/>
        Le texte peut-être modifié par du code via l'attribut "text".<br/>
        <br/>
        Exemple :
        <pre class="code-wrapper">
          <code class="no-highlight gdscript">
            scoreLabel.text = "Score : %s" % score
          </code>
        </pre>
      </section>
      <section id="concepts-Sprite2D">
        <h1>Sprite2D</h1>
        <a href="#/concepts-summary">Retour au sommaire</a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/4.x/classes/class_sprite2d.html" target="_blank">
          Documentation
        </a>
        <br/>
        <br/>
        Sprite2D est une <a href="#/concepts-Node">Node</a> qui permet d'afficher une image (aussi nommé Sprite) dans la
        scène du jeu.
      </section>
      <section id="concepts-CollisionPolygon2D">
        <h1>CollisionPolygon2D</h1>
        <a href="#/concepts-summary">Retour au sommaire</a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/4.x/classes/class_collisionpolygon2d.html" target="_blank">Documentation</a>
        <a href="https://docs.godotengine.org/fr/4.x/tutorials/physics/collision_shapes_2d.html#performance-caveats"
           target="_blank">
          Guide
        </a>
        <br/><br/>
        CollisionPolygon2D est une <a href="#/concepts-Node">Node</a> qui détermine la zone dans laquelle l'objet
        rentrera et détectera la collision avec d'autres objets.<br/>
      </section>
      <section id="concepts-FonctionBases-ready">
        <h1>Fonctions de base 1/3</h1>
        <a href="#/concepts-summary">Retour au sommaire</a> | <a href="#/concepts-FonctionBases-process"><b>_process</b></a>
        | <a href="#/concepts-FonctionBases-physicsProcess"><b>_physics_process</b></a><br/>
        Il existe 3 fonctions importante quand on code un jeu:<br/><br/>
        <h2>_ready()</h2>
        Cette fonction est appelée à la création de l'objet.<br/>
        Elle permet en général d'initialiser l'objet avec des premières données nécessaire à son bon
        fonctionnement.<br/><br/>
        Exemple :
        <pre class="code-wrapper">
          <code data-line-numbers class="no-highlight gdscript" [innerHTML]="readyExample.code"></code>
        </pre>
      </section>
      <section id="concepts-FonctionBases-process">
        <h1>Fonctions de base 2/3</h1>
        <a href="#/concepts-summary">Retour au sommaire</a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/stable/tutorials/scripting/idle_and_physics_processing.html"
           target="_blank">
          Documentation
        </a> |&nbsp;
        <a href="https://www.youtube.com/watch?v=yGhfUcPjXuE" target="_blank">Comprendre le delta</a> |&nbsp;
        <a href="#/concepts-FonctionBases-ready"><b>_ready</b></a> |&nbsp;
        <a href="#/concepts-FonctionBases-physicsProcess"><b>_physics_process</b></a><br/><br/>
        <h2>_process(delta)</h2>
        Cette fonction est appelée à chaque "frame". (Une frame est l'équivalent de l'image d'une pellicule dans un
        film).<br/>
        C'est ici qu'on va appliquer la logique d'un objet.<br/>
        La variable <b>delta</b> correspond au temps passé entre la
        <abbr title="La frame avant celle en cours d'affichage">dernière frame</abbr> et l'avant dernière.<br/>
        Elle permet de lisser le changement d'une valeur pour éviter d'avoir un effet saccadé en jeu.<br/><br/>
        Exemple :
        <pre class="code-wrapper">
              <code class="no-highlight gdscript" [innerHTML]="processExample.code"></code>
            </pre>
      </section>
      <section id="concepts-FonctionBases-physicsProcess">
        <h1>Fonctions de base 3/3</h1>
        <a href="#/concepts-summary">Retour au sommaire</a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/stable/tutorials/scripting/idle_and_physics_processing.html"
           target="_blank">Documentation</a> |&nbsp;
        <a href="https://www.youtube.com/watch?v=yGhfUcPjXuE" target="_blank">Comprendre le delta</a> |&nbsp;
        <a href="#/concepts-FonctionBases-ready"><b>_ready</b></a> |&nbsp;
        <a href="#/concepts-FonctionBases-process"><b>_process</b></a><br/><br/>
        <h2>_physics_process(delta)</h2>
        Cette fonction est similaire à <a href="#/concepts-FonctionBases-process">_process</a>. Elle n'est pas appelée à
        chaque frame, mais à une intervale fixe.<br/>
        Elle est utilisée principalement pour manipuler des objets qui ont une physique.<br/>
        La variable <b>delta</b> correspond au temps passé entre le dernier appel à <i>_physics_process</i> et l'avant
        dernier.<br/><br/>
        Exemple : <br/>
        <pre class="code-wrapper">
          <code class="no-highlight gdscript" [innerHTML]="physicsProcessExample.code"></code>
        </pre>
      </section>
      <section id="concepts-Types">
        <h1>Types</h1>
        <a href="#/concepts-summary">Retour au sommaire</a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/4.x/classes/index.html#variant-types" target="_blank">
          Documentation
        </a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/4.x/tutorials/scripting/gdscript/gdscript_basics.html" target="_blank">
          Guide
        </a>
        <br/><br/>
        Nous avons pu utiliser différents types tels que :
        <dl>
          <dt>
            float
          </dt>
          <dd>C'est un nombre avec des décimales. (Ex: 1.0)</dd>
          <dt>
            Vector2
          </dt>
          <dd>
            C'est sont 2 float qui permettent de déterminer des coordonnées. (Ex: (1.0,2.1))<br/>
            Il peut-être utilisé pour indiquer des positions ou une direction.
          </dd>
          <dt>
            int
          </dt>
          <dd>
            C'est un nombre entier. (Ex: 1)
          </dd>
          <dt>
            String
          </dt>
          <dd>
            C'est une chaine de caractères. (Ex: "Je suis un astéroide.")
          </dd>
          <dt>
            bool
          </dt>
          <dd>
            Un booléen est une valeur constitué des valeurs Vrai ou Faux. (Ex: true/false)<br/>
            Il est notamment utilisé pour appliquer des conditions.
          </dd>
        </dl>
        <br/><br/>
        Il existe plus de types que vous pouvez découvrir dans la <a
        href="https://docs.godotengine.org/fr/4.x/classes/index.html#variant-types" target="_blank">Documentation</a>.
      </section>
      <section id="concepts-Input">
        <h1>Input</h1>
        <a href="#/concepts-summary">Retour au sommaire</a> | <a
        href="https://docs.godotengine.org/fr/4.x/classes/class_input.html" target="_blank">Documentation</a>
        <br/>
        <br/>
        Input est une classe qui permet de savoir quand un joueur réalise une action pour interragir avec le jeu.<br/>
        Il est possible de détecter l'appuye d'un bouton. Ou de détecter la réalisation d'une action.<br/>
        Exemples : <br/>
        <pre class="code-wrapper">
              <code class="no-highlight gdscript">
                  if(Input.is_key_pressed(KEY_Z)):
              </code>
            </pre>
        <pre class="code-wrapper">
              <code class="no-highlight gdscript">
                	if(Input.action_press("ui_accept")):
              </code>
            </pre>
        Dans ce second cas, l'action <i>ui_accept</i> est rattachée à plusieurs touches visibles dans "Projet >
        Paramètres du projet > Contrôles".<br/>
        Vous pourrez ajouter vos propre contrôles via cette interface.<br/>
        Et voir les actions de bases en cochant la case <i>Afficher les Actions intégrées</i>.
      </section>
      <section id="concepts-UniqueName">
        <h1>Unique Name</h1>
        <a href="#/concepts-summary">Retour au sommaire</a><br/>
        <br/>
        Un nom unique (Unique Name) permet de créer un index nommé vers votre Node/objet. Cela permet ensuite
        de l'utiliser dans le code sans avoir à utiliser l'annotation <a href="#/concepts-Export">&#64;export</a>.
        <br/>
        <br/>
        Exemple :
        <div class="container-fluid">
          <div class="row">
            <div class="col">
              <img src="{{imgAssets.uniqueNameExample}}"
                   alt="Extrait de l'arbre de Nodes avec la Node de type Label nommée 'Score' est associée à l'icone 'Unique Name'."/>
            </div>
            <div class="col">
              <pre class="code-wrapper">
                <code class="no-highlight gdscript" [innerHTML]="uniqueName.code">
                </code>
              </pre>
            </div>
          </div>
        </div>
      </section>
      <section id="concepts-Export">
        <h1>&#64;export</h1>
        <a href="#/concepts-summary">Retour au sommaire</a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/4.x/tutorials/scripting/gdscript/gdscript_exports.html"
           target="_blank">
          Guide
        </a>
        <br/><br/>
        Cette annotation quand elle est utilisée avant la déclaration d'une variable de classe, permet de la rendre
        visible dans l'inspecteur de Godot et ainsi de modifier cette valeur en dehors du code.<br/>
        <br/>
        Exemple :
        <div class="container-fluid">
          <div class="row">
            <div class="col">
                  <pre class="code-wrapper">
                    <code class="no-highlight gdscript" [innerHTML]="exportExample.code"></code>
                  </pre>
            </div>
            <div class="col">
              <img src="{{imgAssets.exportExample}}"
                   alt="Extrait de l'inspecteur Godot pour une Node nommée GameMaster et avec une variabel 'vitesse' initialisée à 0."/>
            </div>
          </div>
        </div>
      </section>
      <section id="concepts-Signaux">
        <h1>Signaux</h1>
        <a href="#/concepts-summary">Retour au sommaire</a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/4.x/tutorials/scripting/gdscript/gdscript_basics.html#signals"
           target="_blank">
          Guide
        </a>
        <br/><br/>
        Les signaux permettent des transmettre des messages entre deux scripts/Node/objets sans avoir à les
        référencer via l'annotation <a href="#/concepts-Export">&#64;export</a>.
      </section>
      <section id="concepts-PackedScene">
        <h1>PackedScene</h1>
        <a href="#/concepts-summary">Retour au sommaire</a> |&nbsp;
        <a href="https://docs.godotengine.org/fr/4.x/classes/class_packedscene.html">Documentation</a><br/><br/>
        <b>PackedScene</b> est une fichier (.tscn) qui regroupe un arbre de Nodes.<br/>
        Il permet notamment de faire apparaitre cet arbre autant de fois que nécessaire dans le jeu via la fonction
        <code>instantiate()</code>.
      </section>
    </section>
  </div>
</div>
